#include <WiFi.h>
#include <WiFiUdp.h>

// ===== Wi‑Fi settings =====
const char* ssid     = "72girls";
const char* password = "Rimmaisbabe6969";

const unsigned int udpPort = 8888;
// Define the IP addresses for the left and right servo modules:
const char* leftServoIP = "192.168.0.136";   // Replace with the actual IP for the left servo module
const char* rightServoIP = "192.168.0.135";  // Replace with the actual IP for the right servo module

WiFiUDP udp;

// Joystick analog input pins (adjust if needed)
const int VRX = A0;  // Horizontal axis
const int VRY = A1;  // Vertical axis

void setup() {
  Serial.begin(115200);
  pinMode(VRX, INPUT);
  pinMode(VRY, INPUT);
  
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while(WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("\nWiFi connected!");
  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());
  
  // Initialize UDP on the specified port
  udp.begin(udpPort);
}

void loop() {
  // Read the raw joystick values
  int xVal = analogRead(VRX);
  int yVal = analogRead(VRY);
  
  // Map the raw 12-bit ADC values (0 to 4095) to a range of -100 to 100
  int xSpeed = map(xVal, 0, 4095, -100, 100);
  int ySpeed = map(yVal, 0, 4095, -100, 100);

  // Create a comma-separated control message: "xSpeed,ySpeed"
  String message = String(xSpeed) + "," + String(ySpeed);
  Serial.print("Sending message: ");
  Serial.println(message);
  
  // Send the UDP packet to the left servo module
  udp.beginPacket(leftServoIP, udpPort);
  udp.print(message);
  udp.endPacket();
  
  // Send the UDP packet to the right servo module
  udp.beginPacket(rightServoIP, udpPort);
  udp.print(message);
  udp.endPacket();
  
  delay(50); // Update at roughly 20Hz
}
